##
## Copyright (c) 2022 The Yaook Authors.
##
## This file is part of Yaook.
## See https://yaook.cloud for further info.
##
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
##
##     http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
##
FROM python:3.10.14-slim-bookworm


ARG openstack_release=2024.1
ARG branch=stable/${openstack_release}
ARG ovs_version

ARG neutron_uid=2500007
ARG neutron_gid=2500007

COPY files /build-files

RUN set -eux ; \
    export LANG=C.UTF-8 ; \
    export DEBIAN_FRONTEND=noninteractive ; \
    #
    BUILD_PACKAGES="apt-utils git libssl-dev libcap-ng-dev build-essential patch autoconf automake libtool" ; \
    REQUIRED_PACKAGES="curl sudo" ; \
    #
    apt-get update ; \
    apt-get install -y --no-install-recommends ${BUILD_PACKAGES} ${REQUIRED_PACKAGES} ; \
    git clone -b ${ovs_version} https://github.com/openvswitch/ovs /ovs ; \
    CWD=$PWD ; \
    cd /ovs ; \
    ./boot.sh ; \
    ./configure \
      --localstatedir=/var \
      --sysconfdir=/etc \
      --prefix=/usr/local \
      # We need shared linking for the ovs._json python lib
      # With that lib OVS parses json in C instead of python (huge speed improvement)
      --enable-shared; \
    gmake ; \
    make install ; \
    cd python ; \
    python3 setup.py install ; \
    ldconfig ; \
    cd $CWD ; \
    #
    (git clone https://opendev.org/openstack/requirements.git --depth 1 --branch ${branch} \
      || git clone https://opendev.org/openstack/requirements.git --depth 1 --branch ${openstack_release}-eol \
      || git clone https://opendev.org/openstack/requirements.git --depth 1 --branch unmaintained/${openstack_release}) ; \
    (git clone https://opendev.org/openstack/neutron.git --depth 1 --branch ${branch} \
      || git clone https://opendev.org/openstack/neutron.git --depth 1 --branch ${openstack_release}-eol \
      || git clone https://opendev.org/openstack/neutron.git --depth 1 --branch unmaintained/${openstack_release}) ; \
    (git clone https://opendev.org/openstack/neutron-dynamic-routing.git --depth 1 --branch ${branch} \
      || git clone https://opendev.org/openstack/neutron-dynamic-routing.git --depth 1 --branch ${openstack_release}-eol \
      || git clone https://opendev.org/openstack/neutron-dynamic-routing.git --depth 1 --branch unmaintained/${openstack_release}) ; \
    #
    sed -i '/^neutron===.*/d' /requirements/upper-constraints.txt ; \
    sed -i '/^ovs===.*/d' /requirements/upper-constraints.txt ; \
    if [ -f /neutron-dynamic-routing/lower-constraints.txt ]; then sed -i '/^neutron==.*/d' /neutron-dynamic-routing/lower-constraints.txt; fi ; \
    if [ -f /neutron-dynamic-routing/upper-constraints.txt ]; then sed -i '/^neutron==.*/d' /neutron-dynamic-routing/upper-constraints.txt; fi ; \
    if [ -f /neutron-dynamic-routing/requirements.txt ]; then sed -i '/^neutron>.*/d' /neutron-dynamic-routing/requirements.txt; fi ; \
    git apply --directory neutron /build-files/0005-fix-subnet-X-networkrbacs-join.patch ; \
    git apply --directory neutron /build-files/0006-adds-log-output-to-${openstack_release}-maintenance-routines.patch ; \
    git apply --directory neutron /build-files/0008-OVN-Wait-for-ovn-controller-at-migration.patch; \
    git apply --directory neutron /build-files/0009-acl-comparison-efficiency-2024.1.patch; \
    #
    pip3 install -c requirements/upper-constraints.txt PyMySQL python-memcached pymemcache neutron/ neutron-dynamic-routing/ ; \
    patch -d /usr/local/lib/python3.*/site-packages/oslo_messaging -p 2 -i /build-files/fix-rabbitmq-exchange-declare-fallback.patch ; \
    mkdir /default_policy ; \
    cp /build-files/policies_${openstack_release}.yaml /default_policy/policy.yaml ; \
    #
    groupadd --gid ${neutron_gid} neutron ; \
    adduser --system --uid ${neutron_uid} --gid ${neutron_gid} neutron ; \
    #
    # allow the use of rootwrap with sudo
    cp /build-files/neutron-rootwrap /etc/sudoers.d/neutron-rootwrap ; \
    # rootwrap expects the filters in /usr/share
    mkdir -p /usr/share/neutron/rootwrap ; \
    ln -s /usr/local/etc/neutron/rootwrap.d/rootwrap.filters /usr/share/neutron/rootwrap ; \
    #
    # pre-create /var/lib/neutron as the neutron user will not be able to create it
    mkdir -p /var/lib/neutron ; \
    chown neutron: /var/lib/neutron ; \
    #
    apt-get purge --auto-remove -y ${BUILD_PACKAGES} ; \
    apt-get clean autoclean ; \
    rm -rf requirements neutron neutron-dynamic-routing /var/lib/apt/lists/* /ovs /build-files ; \
    # check that json parsing is working and we use our compiled version
    pip freeze | grep "ovs==$(echo -n ${ovs_version} | cut -c 2-)" ; \
    python3 -c "import ovs._json"

USER neutron

CMD ["neutron-server"]
